#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <time.h>

#define LINESIZE	100
#define BUFSIZE		100 * 1024
#define DIR		"/disk/test"

char *malloc();

main ( argc, argv )
    int argc;
    char *argv[];
{
    int ch;

    chdir ( DIR );
    while ((ch = getopt ( argc, argv, "rw" ) ) != EOF ) {
	switch ( ch ) {
	    case 'r':
		read_files();
		exit(0);
		break;
	    case 'w':
		write_files();
		exit();
		break;
	}
    }
}

read_files()
{
    char *data;
    int i;
    int byte_total = 0;
    int fd;
    int file_size; 
    int amt;
    char buffer[LINESIZE];
    struct stat stat;
    struct timeval before, after;
    struct timezone dummy;
    int sec_total = 0;
    int usec_total = 0;

    data = malloc ( BUFSIZE );
    if ( data == NULL ) {
	err ( 1, "malloc of data buffer failed" );
    }

    while ( fgets ( buffer, LINESIZE, stdin ) != NULL ) {
	for ( i = 0;  i < LINESIZE  &&  buffer[i] != '\0';  i++ ) {
	    if ( buffer[i] == '\n' )
		buffer[i] = '\0';
	}
	fd = open ( buffer, O_RDONLY );
	if ( fd < 0 ) {
	    err ( 1, "Couldn't open file %s", buffer );
	}
	fstat ( fd, &stat );
	file_size = stat.st_size;
	amt = BUFSIZE;
	gettimeofday ( &before, &dummy );
	while ( file_size > 0 ) {
	    if ( file_size < amt )
		amt = file_size;
	    file_size -= read ( fd, data, amt );
	}
	gettimeofday ( &after, &dummy );
	byte_total += stat.st_size;
	sec_total += after.tv_sec - before.tv_sec;
	usec_total += after.tv_usec - before.tv_usec;

	close(fd);
    }
    usec_total += 1000000 * sec_total;
    printf ( "%d bytes read in %d usec ( %4.3f MB/sec )\n", byte_total,
	     usec_total, (float) byte_total / (float) usec_total );
}

write_files()
{
    char *data;
    int i;
    int byte_total = 0;
    int fd;
    int file_size; 
    int amt;
    char buffer[LINESIZE];
    struct stat stat;
    struct timeval before, after;
    struct timezone dummy;
    int sec_total = 0;
    int usec_total = 0;

    data = malloc ( BUFSIZE );
    if ( data == NULL ) {
	err ( 1, "malloc of data buffer failed" );
    }

    while ( fgets ( buffer, LINESIZE, stdin ) != NULL ) {
	for ( i = 0;  i < LINESIZE  &&  buffer[i] != '\0';  i++ ) {
	    if ( buffer[i] == '\n' )
		buffer[i] = '\0';
	}
	fd = open ( buffer, O_RDWR );
	if ( fd < 0 ) {
	    err ( 1, "Couldn't open file %s", buffer );
	}
	fstat ( fd, &stat );
	file_size = stat.st_size;
	amt = BUFSIZE;
	gettimeofday ( &before, &dummy );
	while ( file_size > 0 ) {
	    if ( file_size < amt )
		amt = file_size;
	    file_size -= write ( fd, data, amt );
	}
	gettimeofday ( &after, &dummy );
	byte_total += stat.st_size;
	sec_total += after.tv_sec - before.tv_sec;
	usec_total += after.tv_usec - before.tv_usec;

	close ( fd );
    }
    usec_total += 1000000 * sec_total;
    printf ( "%d bytes written in %d usec ( %4.3f MB/sec )\n", byte_total,
	     usec_total, (float) byte_total / (float) usec_total );
}
